package edu.ub.tfg.josepperez.classificadorapp;

import java.util.ArrayList;

public class Classificador {

    public static final double INTERCEPT = -0.85646468; //terme independent de l'hiperplà de separació
    public static final int MIDA_VECTOR = 512; //mida del vector característic
    public static final int NV = 160; //quantitat de vectors de suport
    public static final double GAMMA_NEG = -0.43; // constant Gamma de la RBF en negatiu
    private double[][] sv;
    private double[] coefs;

    public Classificador(){

    }

    public Classificador(double[][] sv, double[] coefs){
        this.sv = sv;
        this.coefs = coefs;
    }

    public double signe(double[] x){
        double suma = 0;
        for(int i=0;i<NV;i++){
            double normaQuadrat = difQuadrat(sv[i],x);
            suma += coefs[i] * Math.exp(GAMMA_NEG * normaQuadrat);
        }
        suma -= INTERCEPT;
        return Math.signum(suma);
    }

    private double difQuadrat(double[] x, double[] y){
        double suma = 0;
        for(int i=0;i<x.length;i++){
            suma += (x[i]-y[i])*(x[i]-y[i]);
        }
        return suma;
    }

    public int classifica(ArrayList<double[]> espectres){
        int nombreFlautes = 0;
        int nombreSaxos = 0;

        for(int i=0;i<espectres.size();i++){
            if(signe(espectres.get(i))==1.0){
                nombreSaxos += 1;
            }else{
                nombreFlautes += 1;
            }
        }

        if(nombreFlautes >= nombreSaxos){
            return -1;
        }else{
            return 1;
        }

    }
}
