package edu.ub.tfg.josepperez.classificadorapp;

import java.util.ArrayList;
import android.media.AudioFormat;
import android.media.AudioRecord;
import android.media.MediaRecorder;
import android.os.AsyncTask;
import android.util.Log;

public class Gravacio extends AsyncTask<Void, double[], Void> {

    public static final int FREQUENCIA = 8000;
    public static final int BLOCKSIZE = 1024;

    public static boolean started;
    private MainActivity refVista;
    private FourierManager fourierManager;
    private boolean classificat;
    private double[] espectre;

    public Gravacio(boolean start, MainActivity vista){
        started= start;
        refVista = vista;
        fourierManager = new FourierManager(BLOCKSIZE);
        classificat = false;
    }

    @Override
    public Void doInBackground(Void... arg0) {
        int audioEncoding = AudioFormat.ENCODING_PCM_16BIT;
        int channelConfiguration = AudioFormat.CHANNEL_IN_MONO;

        try {

            int bufferSize = AudioRecord.getMinBufferSize(FREQUENCIA,
                    channelConfiguration, audioEncoding);

            AudioRecord audioRecord = new AudioRecord(
                    MediaRecorder.AudioSource.MIC, FREQUENCIA,
                    channelConfiguration, audioEncoding, bufferSize);

            short[] buffer = new short[BLOCKSIZE];


            audioRecord.startRecording();

            try{
                while (started) {
                    int bufferReadResult = audioRecord.read(buffer, 0, BLOCKSIZE);
                    espectre = fourierManager.calculaEspectre(buffer, bufferReadResult);
                    publishProgress(espectre);
                }
            }catch (Exception e) {
                e.printStackTrace();
            }
            audioRecord.stop();
            audioRecord.release();
            setClassificat(true);

        } catch (Throwable t) {
            Gravacio.setStarted(false);
            t.printStackTrace();
            Log.e("AudioRecord", "Recording Failed");
        }

        return null;
    }

    @Override
    public void onProgressUpdate(double[]... toTransform) {
        refVista.refresh(toTransform);

    }

    public static synchronized void setStarted(boolean start){
        started=start;
    }

    public static synchronized boolean getStarted(){
        return started;
    }

    public boolean getClassificat(){
        return classificat;
    }

    public void setClassificat(boolean classificat){
        this.classificat=classificat;
    }

    public double[] getEspectre() {
        return espectre;
    }


}